<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'guestbook';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 留言列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['guestbook']);

    // SQL查询条件
    $where = " WHERE reply_id = '0'";
 
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('guestbook') . $where . " ORDER BY id DESC";
    
    // 验证并获取合法的分页ID
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 15, $page, 'guestbook.php');
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $if_show = $row['if_show'] ? $_LANG['display'] : $_LANG['hidden'];
        $add_time = date("Y-m-d", $row['add_time']);
        
        $book_list[] = array (
                "id" => $row['id'],
                "title" => $row['title'],
                "contact" => $row['contact'],
                "contact_info" => $row['contact_info'],
                "if_show" => $if_show,
                "if_read" => $row['if_read'],
                "ip" => $row['ip'],
                "add_time" => $add_time 
        );
    }
    
    $smarty->assign('book_list', $book_list);
    $smarty->display('guestbook.htm');
} 

/**
 * +----------------------------------------------------------
 * 留言查看
 * +----------------------------------------------------------
 */
elseif ($rec == 'read') {
    $smarty->assign('ur_here', $_LANG['guestbook_read']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['guestbook_list'],
            'href' => 'guestbook.php' 
    ));
    
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';;
    
    // 获取留言信息
    $guestbook = $dou->get_row('guestbook', '*', "id = '$id'");
    $guestbook['add_time'] = date("Y-m-d", $guestbook['add_time']);
    
    // 获取管理员回复
    $sql = "SELECT content, add_time FROM " . $dou->table('guestbook') . " WHERE reply_id = '$id'";
    $query = $dou->query($sql);
    $reply = $dou->fetch_array($query);
    $reply['add_time'] = date("Y-m-d", $reply['add_time']);
    
    // 将留言信息更新为已读
    $read = "UPDATE " . $dou->table('guestbook') . " SET if_read = '1' WHERE id = '$id'";
    $dou->query($read);
    
    $smarty->assign('guestbook', $guestbook);
    $smarty->assign('reply', $reply);
    $smarty->display('guestbook.htm');
} 

/**
 * +----------------------------------------------------------
 * 留言回复
 * +----------------------------------------------------------
 */
elseif ($rec == 'reply') {
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    $ip = $dou->get_ip();
    $add_time = time();
    
    $sql = "INSERT INTO " . $dou->table('guestbook') . " (id, name, content, ip, add_time, reply_id)" . " VALUES (NULL, '$_USER[user_name]', '$_POST[content]', '$ip', '$add_time', '$id')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['guestbook_reply'] . ': ' . $_POST[title]);
    
    $dou->dou_msg($_LANG['guestbook_insert_success'], 'guestbook.php');
} 

/**
 * +----------------------------------------------------------
 * 显示或隐藏
 * +----------------------------------------------------------
 */
elseif ($rec == 'show_hidden') {
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    $if_show = $dou->get_one("SELECT if_show FROM " . $dou->table('guestbook') . " WHERE id = '$id'");
    $if_show = $if_show ? 0 : 1;
    
    // 更新留言信息显示状态
    $read = "UPDATE " . $dou->table('guestbook') . " SET if_show = '$if_show' WHERE id = '$id'";
    $dou->query($read);
    
    echo "<em class=" . ($if_show ? 'd' : 'h') . "><b>$_LANG[display]</b><s>$_LANG[hidden]</s></em>";
} 

/**
 * +----------------------------------------------------------
 * 批量留言删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del_all') {
    if (is_array($_POST['checkbox'])) {
        $checkbox = $dou->create_sql_in($_POST['checkbox']);
        
        // 删除留言
        $sql = "DELETE FROM " . $dou->table('guestbook') . " WHERE id " . $checkbox;
        $dou->query($sql);
        
        $dou->create_admin_log($_LANG['guestbook_del'] . ": GUESTBOOK " . addslashes($checkbox));
        $dou->dou_msg($_LANG['del_succes'], 'guestbook.php');
    } else {
        $dou->dou_msg($_LANG['guestbook_select_empty'], 'guestbook.php');
    }
}

?>