// pages/guestbook/guestbook.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
    guestbook_list: [],
    page: 1,
    nomore: false,
    textAreaMaxLen: 200,
    inputValueLength: 0,
    title: '',
    contact: '',
    contact_info: '',
    content: ''
  },
 
  onShow: function(options) {
    var that = this

    // 判断是否登录
    dou.checkLoginState()
  },
 
  onLoad: function(options) {
    var that = this
        
    that.setData({
      title: app.title.guestbook
    })

    // 显示转发按钮
    dou.showShareMenu()

    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
   
    that.loadData()
  },

  // 获取数据
  loadData: function(concat = false, page = '') {
    var that = this;
    
    wx.request({
      url: app.mp_url + 'guestbook.php',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        page: page ? page : that.data.page, // 从数据里获取当前页数
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        if (concat) {
          var dataBox = that.data.guestbook_list; // 从data获取当前datalist数组
          var dataNew = res.data.guestbook_list; // 从此次请求返回的数据中获取新数组
          
          if (dataNew) {
            dataBox = dataBox.concat(dataNew); // 合并数组
          } else {
            that.setData({
              nomore: true
            })
          }
        } else {
          dataBox = res.data.guestbook_list;
        }

        that.setData({
          guestbook_list: dataBox,
          loadpage: false
        })
       
        // 设置转发标题缓存
        wx.setStorageSync('shareTitle', res.data.title)
      },
    })
  },
 
  onReachBottom: function () { // 触底开始下一页
    var that = this;
    
    if (!that.data.nomore) {
      var page = that.data.page + 1; // 获取当前页数并+1
    
      that.setData({
        page: page, // 更新当前页数
        loadpage: true,//加载动画的显示
      })

      setTimeout (
        function() { //注意function这里不能缺少
          that.loadData(true); // 重新调用请求获取下一页数据
        },1000
      )
    }
  },
 
  submit: function (e) {
    var that = this
    
    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/user/user')
   
    wx.request({
    url: app.mp_url + 'guestbook.php?rec=insert',
    data: {
      user_id: wx.getStorageSync('user_id'),
      shell: wx.getStorageSync('shell'),
      title: e.detail.value.title,
      contact: e.detail.value.contact,
      contact_info: e.detail.value.contact_info,
      content: e.detail.value.content
    },
    method:'POST',
    header: {
      'Connect-Key' : wx.getStorageSync('connect_key'),
      'Content-Type': 'application/x-www-form-urlencoded'
    },
    success: function (res) {
      if (res.data.wrong) {
        that.setData({
          wrong: res.data.wrong
        });
      } else if (res.data.is_water) {
        dou.douMsg(res.data.is_water, '/pages/user/edit')
      } else {
        wx.showToast({
          title: that.data.lang.guestbook_insert_success,
          icon: 'success',
          duration: 1000,
          success: res => {
            that.setData({
              title: '',
              contact: '',
              contact_info: '',
              content: ''
            });
            that.loadData()
          }
        });
      }
    }
   })
  },
 
  bindKeyInput: function (e) {
    if(e.detail.value.length > 200){
      this.setData({
        inputValueLength:200,
        inputValue: e.detail.value
      })
    }else{
      this.setData({
        inputValueLength:e.detail.value.length,
        inputValue: e.detail.value
      })
    }
  },
 
  bindPickerChange: function (e) {
    this.setData({
      index: e.detail.value
    })
  },

  // 设置转发标题
  onShareAppMessage: function (options) {
    return {
      title: wx.getStorageSync('shareTitle')
    }
  }

})