<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'guestbook';
require (dirname(__FILE__) . '/include/init.php');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 权限验证
$callback = $dou_user->check_login_state(); // 登录验证
if ($callback['msg'] == 'ok') {
    $user_id = $callback['user_id'];
} else {
    if (!in_array($rec, $nomust_login_array)) {
        $data['wrong'] = $_LANG['login_timeout'];
        die(json_encode($data));
    }
}

// 错误提示初始
$data['wrong'] = '';

/**
 * +----------------------------------------------------------
 * 留言板
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $GLOBALS['dou']->table('guestbook') . " WHERE if_show = '1' OR user_id = '$user_id' ORDER BY id DESC";

    // 获取分页信息
    $page = $check->is_number($_REQUEST['page']) ? trim($_REQUEST['page']) : 1;
    $limit = $dou->pager($sql, 10, $page);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $GLOBALS['dou']->query($sql);
    while ($row = $GLOBALS['dou']->fetch_array($query)) {
        // 获取管理员回复
        $reply = "SELECT content, add_time FROM " . $dou->table('guestbook') . " WHERE reply_id = '$row[id]'";
        $reply = $dou->fetch_array($dou->query($reply));
        $reply_time = date("Y-m-d", $reply['add_time']);
        
        $guestbook_list[] = array (
                "id" => $row['id'],
                "title" => $row['title'],
                "contact" => $row['contact'],
                "content" => $row['content'],
                "add_time" => date("Y-m-d", $row['add_time']),
                "reply" => $reply['content'],
                "reply_time" => $reply_time 
        );
    }
 
    // 数据封装
    $data['title'] = $_LANG['guestbook'];
    $data['guestbook_list'] = $guestbook_list;
}

/**
 * +----------------------------------------------------------
 * 留言添加
 * +----------------------------------------------------------
 */
if ($rec == 'insert') {
    $ip = $dou->get_ip();
    $add_time = time();
        
    // 验证主题
    if (empty($_POST['title']) || $check->is_illegal_char($_POST['title']))
        $wrong['title'] = $_LANG['guestbook_title_wrong'];
    
    // 验证联系人
    if (empty($_POST['contact']) || $check->is_illegal_char($_POST['contact']))
        $wrong['contact'] = $_LANG['guestbook_contact_wrong'];
    
    // 验证联系方式
    if (!$check->is_telphone($_POST['contact_info']) && !$check->is_email($_POST['contact_info']))
        $wrong['contact_info'] = $_LANG['guestbook_contact_info_wrong'];
    
    // 验证留言内容
    if (empty($_POST['content']) || $check->is_illegal_char($_POST['content']))
        $wrong['content'] = $_LANG['guestbook_content_wrong'];
    
    // 错误提示
    $data['wrong'] = $wrong;
    if ($data['wrong']) {
        echo json_encode($data);
        exit;
    }
 
    // 检查IP是否频繁咨询
    if (is_water($ip)) {
        $data['is_water'] = $_LANG['guestbook_is_water'];
        die(json_encode($data));
    }

    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);
    
    $sql = "INSERT INTO " . $dou->table('guestbook') . " (id, user_id, title, contact, contact_info, content, ip, add_time)" . " VALUES (NULL, '$user_id', '$_POST[title]', '$_POST[contact]', '$_POST[contact_info]', '$_POST[content]', '$ip', '$add_time')";
    $dou->query($sql);
}

echo json_encode($data);

/**
 * +----------------------------------------------------------
 * 防灌水
 * +----------------------------------------------------------
 */
function is_water($ip) {
    $unread_messages = $GLOBALS['dou']->get_one("SELECT COUNT(*) FROM " . $GLOBALS['dou']->table('guestbook') . " WHERE ip = '$ip' AND if_read = 0 AND reply_id = 0");
    
    // 如果管理员未回复的留言数量大于1
    if ($unread_messages > '1')
        return true;
}

?>